<template>
  <v-app id="inspire">
    <v-main>
      <v-container fluid>
        <v-row
          v-if="displayPosts.length > 0"
          align="center"
          justify="center"
        >
          <v-card
            v-for="post in displayPosts"
            :key="post.id"
            class="mb-4 pa-5 flex-grow-1 full-width"
          >
            <v-card-text>
              <v-row>
                <v-col class="col-3 col-md-2" align="center" justify="center">
                  <v-avatar color="grey" class="mr-4">
                    <v-icon>mdi-image</v-icon>
                  </v-avatar>
                  <p class="caption mt-5">
                    {{ post.file }}
                  </p>
                </v-col>
                <v-col>
                  <div class="d-flex flex-nowrap justify-space-between">
                    <strong class="title">{{ post.title }}</strong>
                    <v-btn icon @click="remove(post.id)">
                      <v-icon>mdi-delete</v-icon>
                    </v-btn>
                  </div>
                  <p class=" mt-5">
                    {{ post.text }}
                  </p>
                </v-col>
              </v-row>
            </v-card-text>
          </v-card>
          <div />
        </v-row>
        <v-row v-else>
          <v-card-text>
            <div class="subtitle-1" align="center" justify="center">
              Статей нет. Желаете
              <nuxt-link to="/add-post">
                добавить
              </nuxt-link>
              ?
            </div>
          </v-card-text>
        </v-row>
      </v-container>
      <ModalDeletePost ref="modalDeletePost" @remove="removePost" />
    </v-main>
  </v-app>
</template>

<script>
import { mapGetters } from 'vuex'
import ModalDeletePost from '~/components/modalDeletePost'

export default {
  components: {
    ModalDeletePost
  },

  computed: {
    ...mapGetters(['isAuthenticated', 'loggedInUser']),
    deleteModal () {
      return this.$refs.modalDeletePost
    },
    displayPosts () {
      if (this.isAuthenticated) {
        return this.loggedInUser.user.posts
      } else {
        return []
      }
    }
  },

  mounted () {
    if (this.isAuthenticated) {
      this.$auth.fetchUser()
    } else {
      this.$router.push('/login')
    }
  },

  methods: {
    remove (id) {
      this.deleteModal.askRemove(id)
    },
    async removePost (id) {
      try {
        await this.$axios.delete(`post/${id}`)

        this.$auth.fetchUser()
      } catch (e) {
        this.error = e.response.data.error
      }
    }
  },

  head () {
    return {
      title: 'Мои статьи',
      meta: [
        {
          hid: 'Мои статьи',
          name: 'Мои статьи',
          content: 'Мои статьи'
        }
      ]
    }
  }
}
</script>

<style lang="scss" scoped>
.v-card {
  &.full-width {
    width: 100%;
  }
}
</style>
